<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  Disclaimer,
  GartnerForm,
  Hero,
} from '../../components/gartner/index.vue';
import { NextStepAlt } from '@/components/common/index.vue';
import { getPageMetadata } from '~/common/meta';
import { LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';

export default Vue.extend({
  components: {
    NextStepAlt,
    Hero,
    GartnerForm,
    Disclaimer,
  },
  mixins: [LivePreviewMixin],
  layout: 'no-banner',
  async asyncData({ $gartnerMagicQuadrantService }: any) {
    try {
      const { gartner, items } = await $gartnerMagicQuadrantService.getContent(
        'resources/study-forrester-tei-gitlab-ultimate',
      );

      return { gartner, items };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).gartner, this.$route.path);
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.gartner =
            this.$gartnerMagicQuadrantService.transformContentfulData(
              updatedData,
            )),
      });

      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div v-if="gartner" class="container-gartner">
    <Hero v-bind="gartner.hero" :gartner-m-q-landing="true" />
    <SlpContainer v-if="gartner.copyForm" id="copyForm">
      <GartnerForm v-bind="gartner.copyForm" />
    </SlpContainer>
    <Disclaimer v-if="gartner.disclaimer" v-bind="gartner.disclaimer" />
    <NextStepAlt />
  </div>
</template>

<style lang="scss" scoped>
.container-gartner {
  overflow: hidden;
  max-width: 100vw;
  background-color: #f2f1f5;
}
#hero {
  background-color: #2f2a6b;
}
</style>
